/*  
    I haven't coded for 20 years plus
    I am not familiar with Javascript -
    I am sorry for the messi code :)   
*/

// include the api
const { refObject, world, Color, Rotator, Vector, Dice } = require('@tabletop-playground/api');

const testRun = false; // to be set manually
const hiColor = new Color(1, 1, 0, 1); // yellow is highlighting color
const loColor = new Color(1, 1, 1, 1); // white is the low color

diceRotation = [new Rotator(0,0,0),new Rotator(0,0,0)];

/* add a function to roll the dice */

refObject.onReleased.add(
    function(diceObj) {
        diceObj.setRotation(new Rotator(Math.random()*360,Math.random()*360,Math.random()*360))
    }
)

/* add a function to read the dice */

refObject.onMovementStopped.add(
    function (diceObj) {

        if (gameOver) return;

        var notIdle = Math.round(diceObj.getRotation()[0]) % 90;

        if (testRun) console.log(" notIdle = "+notIdle+", "+diceObj.getRotation());

        if (notIdle != 0) // prevent re-dicing and whobbling;
        {
            diceObj.applyImpulse(new Vector(1,0,0)); // push the dice to get it out of the bouncing loop 
            return 
        }
        
        // move back the dices so that they do not drift off the table
        if (diceObj == dice1) {diceObj.setPosition(dice1LOC,1)} else {diceObj.setPosition(dice2LOC,1)};

        let diceIndex = 0.5 + 0.5*(actualPlayer); // needed to index the orientation storage

        if (testRun) console.log("diceIndex = "+diceIndex+" diceRolled = "+diceRolled+" Salta = "+foundSalta);

        if (diceRolled || foundSalta) 
        { 
            if (diceObj === dice2) 
            {
                diceObj.setRotation(diceRotation[1]);
                if (testRun) console.log("!");
                return; 
            }
            else 
            {
                diceObj.setRotation(diceRotation[0]);
                if (testRun) console.log("!!");
                return;
            } 
        };

        if (testRun) console.log("!!!");

        // block reading the dice when it's not the oponents turn
        if ((actualPlayer ===  GREEN) && (diceObj === dice1)) {diceObj.setRotation(diceRotation[0]); return;}
        if ((actualPlayer === RED) && (diceObj === dice2)) {diceObj.setRotation(diceRotation[1]); return;}

        if (testRun) console.log("!!!!");

        if (diceIs === 7) return; // dice is disabled due to Salta

        diceObj.setSecondaryColor(new Color(1,1,1)); // highlight the dice

        diceRotation[diceIndex] = diceObj.getRotation();
        diceRotation[diceIndex][0] = Math.round(diceRotation[diceIndex][0]); // to prevent dice bouncing

        diceIs = parseInt(diceObj.getCurrentFaceName());

        if (diceIs < 5) { // it is for picking a piece

            var actualColor = "g"; if (actualPlayer < 0) actualColor = "r"; 
            var sunPiece = world.getObjectById(diceIs+"p"+actualColor+"$");
            var starPiece = world.getObjectById(diceIs+"s"+actualColor+"$");

            if ((sunPiece.getMetallic() != 0) && (starPiece.getMetallic() != 0)) diceIs = 5; 
            // no reason to move - the pieces are in their target position!

            if (isFramed(sunPiece) && isFramed(starPiece)) diceIs = 5;
            if (testRun) console.log("sunPiece = "+ isFramed(sunPiece) + ", starPiece = "+isFramed(starPiece));
            // cannot move - the pieces are blocked by other pieces!
        };
    
        diceRolled = true; // don not move - must be set before switchHand()

        if (diceIs === 5) { // turn the table
            foundSalta = findSalta(actualPlayer); // do not move this line; has to be called before switching player!
            switchHand(); // see globalEvents.js
            diceIs = -1;
        }

    });


var isFramed = function(obj) {

    const spikeStart = 1.8; // the probe we stick out to find other pieces
    const spikeStop = 5;

    var lockedInCounter = 0;

    var LC = obj.localPositionToWorld(); // remember the local position of the current piece
    var atEdgeX = (Math.abs(Math.round(LC[0])) == 14)
    var atEdgeY = (Math.abs(Math.round(LC[1])) == 14); // are we at one of the edges of the board?

    var lockedInCounter = 2 * (atEdgeX || atEdgeY); // being at an edge restricts possible movements two max. 2 
    if (atEdgeX && atEdgeY) lockedInCounter++; // being in a corner restricts even further to max. 1 movement
    
    // poking 45 degree to starboard
    var from = LC.add(new Vector(spikeStart * actualPlayer,  spikeStart * actualPlayer, 0));
    var to = LC.add(new Vector(spikeStop * actualPlayer, spikeStop * actualPlayer, 0));
    var matches = (world.lineTrace(from, to)!=0); // the probe is sent 
    if (matches) lockedInCounter++;

    if (testRun) world.drawDebugLine(from, to, new Color(0, 1, 0, 255), 1, 0.1);
    
    // poking 135 degree behind
    from = LC.add(new Vector(-spikeStart * actualPlayer,  spikeStart * actualPlayer, 0));
    to = LC.add(new Vector(-spikeStop * actualPlayer, spikeStop * actualPlayer, 0)); 
    matches = (world.lineTrace(from, to)!=0); // the probe is sent 
    if (matches) lockedInCounter++;

    if (testRun) world.drawDebugLine(from, to, new Color(0, 1, 0, 255), 1, 0.1);

    // poking 225 degree behind
    from = LC.add(new Vector(-spikeStart * actualPlayer,  -spikeStart * actualPlayer, 0));
    to = LC.add(new Vector(-spikeStop * actualPlayer, -spikeStop * actualPlayer, 0)); 
    matches = (world.lineTrace(from, to)!=0); // the probe is sent 
    if (matches) lockedInCounter++;

    if (testRun) world.drawDebugLine(from, to, new Color(1, 0, 0, 255), 1, 0.1);

    // poking 45 degree to port
    from = LC.add(new Vector(spikeStart * actualPlayer,  -spikeStart * actualPlayer, 0));
    to = LC.add(new Vector(spikeStop * actualPlayer, -spikeStop * actualPlayer, 0));
    matches = (world.lineTrace(from, to)!=0); // the probe is sent 
    if (matches) lockedInCounter++;

    if (testRun) world.drawDebugLine(from, to, new Color(1, 0, 0, 255), 1, 0.1);

    return (lockedInCounter === 4);
};

/*
 * Look for salta pieces at the given position, 
 * determine the jump condition and return it if existing
 */

var findSalta = function (playerOne) {

    const spikeStart = 1.8; // the probe we stick out to find other pieces
    const spikeStop = 5;

    var salta = false;

    var refColor = "g"; if (playerOne < 0) refColor = "r"; // the color of the piece that just has been moved

    if (testRun) console.log("---");
 
    for (var n = 0; n < allObjects.length; n++) { // loop over all pieces
 
        var nowObject = allObjects[n];
        var nowObjectName = nowObject.getTemplateName();
 
        if (nowObjectName.includes("$")) { // only pieces shall pass
 
            var nowColor = nowObjectName[2]; // the color is defined by the 3rd char in the piece model name
 
            if (nowColor === refColor) // investigate only objects of the color of the refObject  
            {
                nowObject.setPrimaryColor(loColor); // reset salta marking probably set before
 
                var LC = nowObject.localPositionToWorld(); // remember the local position of the current piece
                var atEdge = (Math.abs(Math.round(LC[0])) == 14) || (Math.abs(Math.round(LC[1])) == 14); // are we at one of the edges of the board?
 
                 // poking 45 degree to port
                var from = LC.add(new Vector(spikeStart * actualPlayer,  -spikeStart * actualPlayer, 0));
                var to = LC.add(new Vector(spikeStop * actualPlayer, -spikeStop * actualPlayer, 0));
                var matches = world.lineTrace(from, to); // the probe is sent 
 
                if (testRun) world.drawDebugLine(from, to, new Color(1, 0, 0, 255), 1, 0.1);
 
                if (matches.length > 0) // if any object was detected and it is an oponent 
                {
                    var prtObj = matches[0].object;  // there can only max one                
                    var prtColor = prtObj.getTemplateName()[2]; // 3rd char = color
 
                    if  (!atEdge && (prtColor != nowColor)) { // we are not at the edge of the baord and it is an oponent
 
                        if (testRun) console.log(nowObject.getTemplateName(),"found",prtObj.getTemplateName(),"on port side");
 
                        // poking 135 degree behind
                        from = LC.add(new Vector(-spikeStart * actualPlayer,  spikeStart * actualPlayer, 0));
                        to = LC.add(new Vector(-spikeStop * actualPlayer, spikeStop * actualPlayer, 0)); 
                        var objBehind = world.lineTrace(from, to);
 
                        if (testRun) world.drawDebugLine(from, to, new Color(1, 0, 0, 255), 1, 0.1);
 
                        if (objBehind.length === 0) {
                        // There is an empty field behind!  
                            if (testRun) console.log(prtObj.getTemplateName(),"von ",nowObject.getTemplateName()," markiert");
                            prtObj.setPrimaryColor(hiColor); 
                            salta = true; 
                        };
                    };
                };
 
                // poking 45 degree to starboard
                from = LC.add(new Vector(spikeStart * actualPlayer,  spikeStart * actualPlayer, 0));
                to = LC.add(new Vector(spikeStop * actualPlayer, spikeStop * actualPlayer, 0));
                matches = world.lineTrace(from, to); // the probe is sent 
             
                if (testRun) world.drawDebugLine(from, to, new Color(0, 1, 0, 255), 1, 0.1);
 
                if (matches.length > 0)   // if any object was detected
                {               
                    var stbObj = matches[0].object;
                    var stbColor = stbObj.getTemplateName()[2];  // 3rd char = color
 
                    if  (!atEdge && (stbColor != nowColor)) { // we are not at the edge of the board and it is an oponent
 
                        if (testRun) console.log(nowObject.getTemplateName(),"found",stbObj.getTemplateName(),"on port side");
 
                        // poking 225 degree behind
                        from = LC.add(new Vector(-spikeStart * actualPlayer,  -spikeStart * actualPlayer, 0));
                        to = LC.add(new Vector(-spikeStop * actualPlayer, -spikeStop * actualPlayer, 0)); 
                        objBehind = world.lineTrace(from, to);
 
                        if (testRun) world.drawDebugLine(from, to, new Color(0, 1, 0, 255), 1, 0.1);
 
                        if (objBehind.length === 0) // There is an empty field behind!  
                        {
                            if (testRun) console.log(stbObj.getTemplateName(),"von ",nowObject.getTemplateName()," markiert");
                            stbObj.setPrimaryColor(hiColor); 
                            salta = true;
                        };
                    };
                };
            };
        };
    };
    
    return salta;
 }
